#include <windows.h>
#include <alchemw.h>
#include "resource.h"

#define INIT			0
#define OKPASSWORD 	1
#define QUIT			2

typedef struct tagDataStruct {
	char szPassword[25];
	char szScreen[25];
} DATASTRUCT;

HINSTANCE hInstanceGlb;

int 	WINAPI _export LibMain(HINSTANCE,WORD,WORD,LPSTR);
int 	WINAPI _export WEP(int);
void 	WINAPI _export PlugDestroy(LPSLOT);
WORD 	WINAPI _export PlugType(LPSLOT,LPSTR);
WORD 	WINAPI _export PlugProcess(LPSLOT);
BOOL 	WINAPI _export PlugUnique(LPSLOT,LPCSTR,LPSTR);
WORD	WINAPI _export PlugDialog(LPSLOT,WORD);
WORD 	WINAPI _export PlugButton(LPSLOT,WORD);
BOOL 	WINAPI _export PlugData(LPSLOT,BOOL,void FAR*);
BOOL 	WINAPI _export PlugMouse(LPSLOT,BYTE,WORD,WORD);
void	WINAPI _export PlugActivate(LPSLOT,BOOL);
void	WINAPI _export PlugPaint(LPSLOT,HDC,BOOL,RECT*);
void	WINAPI _export PlugResize(LPSLOT,WORD,WORD);

#pragma argsused
int WINAPI _export LibMain(HINSTANCE hInstance,WORD wDataSegment,WORD wHeapSize,LPSTR lpszCmdLine ) {
	hInstanceGlb = hInstance;
	return TRUE;
}
#pragma argsused
int WINAPI _export WEP(int bSystemExit) {
	return 1;
}
#pragma argsused
void WINAPI _export PlugActivate(LPSLOT hSlot,BOOL activate) {
	return;
}
#pragma argsused
void WINAPI _export PlugPaint(LPSLOT hSlot,HDC dc,BOOL erase,RECT *rect){
	return;
}
#pragma argsused
void WINAPI _export PlugResize(LPSLOT hSlot,WORD width,WORD height) {
	return;
}
#pragma argsused
BOOL WINAPI _export PlugUnique(LPSLOT hSlot,LPCSTR args,LPSTR message) {
	return TRUE;
}
#pragma argsused
BOOL WINAPI _export PlugMouse(LPSLOT hSlot,BYTE code,WORD x,WORD y) {
	return AL_IDLE;
}
#pragma argsused
BOOL WINAPI _export PlugData(LPSLOT hSlot,BOOL more,void FAR *data) {
	return FALSE;
}
#pragma argsused
void WINAPI _export PlugDestroy(LPSLOT hSlot ) {
	AlFree(hSlot);
}
#pragma argsused
WORD WINAPI _export PlugButton(LPSLOT hSlot,WORD id) {
	AlMouseRelease(hSlot);
	AlReleaseButton(hSlot);
	return AL_IDLE;
}
#pragma argsused
WORD WINAPI _export PlugType(LPSLOT hSlot, LPSTR title) {

	DATASTRUCT * ds;

	AlAlloc(hSlot,50);
	AlCaption(hSlot,"Plug-In : JDS Password");
	ds = (DATASTRUCT *) AlLock(hSlot);
	AlArgs(hSlot,ds->szScreen,25);
	GetPrivateProfileString(ds->szScreen,"Password",NULL,ds->szPassword,25,"scrpass.ini");
	AlSetState(hSlot,INIT);
	AlUnlock(hSlot);
	return AL_WIN_HIDDEN;

}
#pragma argsused
WORD WINAPI _export PlugDialog(LPSLOT hSlot,WORD result) {

	WORD State;
	DATASTRUCT* ds;
	WORD nRetVal;
	char szPassword[25];

	State = AlGetState(hSlot);
	nRetVal = AL_IDLE;
	switch (State) {
		case INIT:
			ds = (DATASTRUCT*) AlLock(hSlot);
			if (result == IDOK) {
				AlGetText(hSlot,IDC_PASSWORD,szPassword,25);
				if (lstrcmpi(szPassword,ds->szPassword) == 0)
					AlSetState(hSlot,OKPASSWORD);
				else
					AlSetState(hSlot,QUIT);
			}
			else {
				AlSetState(hSlot,QUIT);
			}
			AlUnlock(hSlot);
			nRetVal = AL_OK;
		break;
	}
	return nRetVal;
}
#pragma argsused
WORD WINAPI _export PlugProcess(LPSLOT hSlot) {

	WORD nState;
	WORD nRetVal;
	DATASTRUCT* ds;

	ds = (DATASTRUCT*) AlLock(hSlot);
	nRetVal = AL_IDLE;
	nState = AlGetState(hSlot);
	switch (nState) {
		case INIT:
			AlLoadDialog(hSlot,MAKEINTRESOURCE(IDD_PASSWORD),hInstanceGlb);
			AlLimitText(hSlot,IDC_PASSWORD,25);
			AlExecDialog(hSlot);
			nRetVal = AL_IDLE;
		break;
		case OKPASSWORD:
			AlChainScreen(hSlot,ds->szScreen);
			AlSetState(hSlot,QUIT);
			nRetVal = AL_OK;
		break;
		case QUIT:
			nRetVal = AL_DIE;
		break;
	}
	AlUnlock(hSlot);
	return nRetVal;
}

